/* LED counter GNOME panel applet
 * Insprired by Sixtyfour bit counter by Tim Gerla
 * and xled by Jan Schoenepauck <schoenep@uni-wuppertal.de>
 * and Joachim Gassen <gassen@uni-muenster.de>"
 *
 * By Uwe Steinmann <Uwe.Steinmann@fernuni-hagen.de>
 *
 * Enjoy.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or 
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License  
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include <applet-widget.h>
#include <glib.h>
#include "gsteak.h"

#define BIG_ICON_SIZE   48

static GtkWidget *pb;

extern int popup_width;
extern int popup_height;
extern int kontext_variable;
extern int german_variable;
extern int english_variable;
extern int case_sensitive_variable;
extern int normal_and_or;

static void apply_cb(GtkObject *pb, gpointer p)
{
	char *buf;
	GtkWidget *widget_s;

	GtkWidget *width_s = gtk_object_get_data(GTK_OBJECT(pb),"width");
	GtkWidget *height_s = gtk_object_get_data(GTK_OBJECT(pb),"height");

	buf = gtk_entry_get_text(GTK_ENTRY(height_s));
	sscanf(buf, "%d", &popup_height);
	buf = gtk_entry_get_text(GTK_ENTRY(width_s));
	sscanf(buf, "%d", &popup_width);

	/**** German ****/
	widget_s = gtk_object_get_data(GTK_OBJECT(pb), "german");
	german_variable = GTK_TOGGLE_BUTTON(widget_s)->active ? 1 : 0;

	/**** English ****/
	widget_s = gtk_object_get_data(GTK_OBJECT(pb), "english");
	english_variable = GTK_TOGGLE_BUTTON(widget_s)->active ? 1 : 0;

	/**** Context ****/
	widget_s = gtk_object_get_data(GTK_OBJECT(pb), "context");
	kontext_variable = GTK_TOGGLE_BUTTON(widget_s)->active ? 1 : 0;
}

static void
changed_cb(GtkWidget *w, GtkWidget *d)
{	
	gnome_property_box_changed(GNOME_PROPERTY_BOX(pb));
}

void
prefs_cb(GtkWidget *w, gpointer p) {
	GtkWidget *frame, *hbox, *tbox, *label, *spin_label, *cadre, *checkbox;
	GtkAdjustment *adj;
	char buffer[30];

	pb = gnome_property_box_new();
	gtk_window_set_title(GTK_WINDOW(pb), _("gsteak Preferences"));
	
	frame=gtk_vbox_new(FALSE,0);

	gnome_property_box_append_page(GNOME_PROPERTY_BOX(pb), frame,
                       gtk_label_new(_("General")));
	
	cadre=gtk_frame_new(_("Popup-window geometry"));
	gtk_widget_show(cadre);
	tbox=gtk_vbox_new(FALSE,5);
	gtk_widget_show(tbox);
	
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE, 2);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("Width"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	adj=(GtkAdjustment *)gtk_adjustment_new(popup_width,100.0,1000.0,1,1,1);
	spin_label=gtk_spin_button_new(adj,1,0);
	gtk_object_set_data(GTK_OBJECT(pb), "width", spin_label);
	gtk_box_pack_start(GTK_BOX(hbox),spin_label,FALSE,FALSE,5);
	gtk_widget_show(spin_label);
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",GTK_SIGNAL_FUNC(changed_cb),NULL);
	gtk_signal_connect_object(GTK_OBJECT(spin_label),"changed",GTK_SIGNAL_FUNC(changed_cb),NULL);

	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE, 2);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("Height"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	adj=(GtkAdjustment *)gtk_adjustment_new(popup_height,50,1200.0,1,1,1);
	spin_label=gtk_spin_button_new(adj,1,0);
	gtk_object_set_data(GTK_OBJECT(pb), "height", spin_label);
	gtk_box_pack_start(GTK_BOX(hbox),spin_label,FALSE,FALSE,5);
	gtk_widget_show(spin_label);
	gtk_signal_connect_object(GTK_OBJECT(adj),"value_changed",GTK_SIGNAL_FUNC(changed_cb),NULL);
	gtk_signal_connect_object(GTK_OBJECT(spin_label),"changed",GTK_SIGNAL_FUNC(changed_cb),NULL);

	gtk_container_add(GTK_CONTAINER(cadre),tbox);
	gtk_box_pack_start(GTK_BOX(frame),cadre,FALSE,FALSE,5);
	
	cadre=gtk_frame_new(_("Language"));
	gtk_widget_show(cadre);
	tbox=gtk_vbox_new(FALSE,5);
	gtk_widget_show(tbox);
	
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE, 2);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("English"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	checkbox = gtk_check_button_new_with_label (_("On/Off"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), english_variable);
	sprintf(buffer, "english");
	gtk_object_set_data(GTK_OBJECT(pb), buffer, checkbox);
	gtk_box_pack_start(GTK_BOX(hbox),checkbox,FALSE,FALSE,5);

	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(changed_cb), NULL);
	
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE, 2);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("German"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	checkbox = gtk_check_button_new_with_label (_("On/Off"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), german_variable);
	sprintf(buffer, "german");
	gtk_object_set_data(GTK_OBJECT(pb), buffer, checkbox);
	gtk_box_pack_start(GTK_BOX(hbox),checkbox,FALSE,FALSE,5);

	gtk_container_add(GTK_CONTAINER(cadre),tbox);
	gtk_box_pack_start(GTK_BOX(frame),cadre,FALSE,FALSE,5);
	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(changed_cb), NULL);

	cadre=gtk_frame_new(_("Context"));
	gtk_widget_show(cadre);
	tbox=gtk_vbox_new(FALSE,5);
	gtk_widget_show(tbox);
	
	hbox=gtk_hbox_new(FALSE,5);
	gtk_box_pack_start(GTK_BOX(tbox),hbox,FALSE,FALSE, 2);
	gtk_widget_show(hbox);
	label=gtk_label_new(_("Context"));
	gtk_box_pack_start(GTK_BOX(hbox),label,FALSE,FALSE,5);
	gtk_widget_show(label);
	checkbox = gtk_check_button_new_with_label (_("On/Off"));
	gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(checkbox), kontext_variable);
	sprintf(buffer, "context");
	gtk_object_set_data(GTK_OBJECT(pb), buffer, checkbox);
	gtk_box_pack_start(GTK_BOX(hbox),checkbox,FALSE,FALSE,5);
	gtk_signal_connect(GTK_OBJECT(checkbox), "toggled",
                   	GTK_SIGNAL_FUNC(changed_cb), NULL);

	gtk_container_add(GTK_CONTAINER(cadre),tbox);
	gtk_box_pack_start(GTK_BOX(frame),cadre,FALSE,FALSE,5);

	gtk_signal_connect(GTK_OBJECT(pb), "apply",
                           GTK_SIGNAL_FUNC(apply_cb), pb);
	gtk_signal_connect(GTK_OBJECT(pb), "destroy",
                           GTK_SIGNAL_FUNC(gtk_widget_destroyed),&pb);

	gtk_widget_show_all(pb);
}
